/********************************************************************
   TORNADO-E54x DCM Demo Utility.
   SIOX/PIOX TM/XIO-0/1 timer pins test. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo configures SIOX/PIOX TM/XIO-0/1 pins as timers.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch SW2:
	  - no BOOT mode
	  - HPI is disabled (for E5402)
***********************************************************************/


#include "te54x_d.h"
#include "c54x_def.h"


main()
{
   TE54X_init_for_xdm_dram();

	// configure TM/XIO-0 as TIMER output
   TE54X_SET_XIO0_CNF_TIMER;

	// initialize TIMER
   *C54X_TM_TCR	= 0x14;	// initialize timer TOUT
   *C54X_TM_PRD = 0x10;
   *C54X_TM_TCR = 0x4;

	// configure TM/XIO-1 as TIMER output for E5402 board in case HPI is disabled
   if(TE5402_BOARD && TE54X_HPI_ENABLE_IS_OFF)
	{
		TE54X_SET_XIO1_CNF_TIMER;

		// enable TOUT1 output at HPI_HINT
		*C54X_GPIOCR |= C5402_GPIOCR_TOUT1_BITMASK;

		// initialize TIMER#1
		*C54X_TM1_TCR = 0x14;	
		*C54X_TM1_PRD = 0x20;
		*C54X_TM1_TCR = 0x4;
	}

   while(1);
}



