/********************************************************************
   TORNADO-E54x DCM Demo Utility.
   Test for HPI port as 8-bit I/O pins (E5402/E6509/E5416 only with HPI disabled). rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo configures HPI port as 8-bit parallel OUTPUT pins and
	continuously load 'running 1' over these pins. This demo runs at
	E5402, E5409 and E5416 boards only with HPI port disabled.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch SW2:
	  - no BOOT mode
	  - HPI is disabled (for E5402/E5409/E5416)
***********************************************************************/


#include "te54x_d.h"
#include "c54x_def.h"


main()
{  unsigned i,d;
 
   TE54X_init_for_xdm_dram();

	// run this test for E5402/E5409/E5416 boards only with HPI enable
   if(     (TE5402_BOARD | TE5409_BOARD | TE5416_BOARD) 
	&& TE54X_HPI_ENABLE_IS_OFF
     )
	{
		// configure HPI pins as OUTPUTS
		*C54X_GPIOCR = 0xff;	

		// perform 'running 1' test for HPI output pins
		while(1)
		{
		  // reset all HPI outputs
		  d=0; 
		  *C54X_GPIOSR = d;				

		  // generate 'running 1'		  
		  for(i=1,d=1;i<=8;i++, d <<= 1)
			*C54X_GPIOSR = d;				
		}
	}
}



