/********************************************************************
   TORNADO-E54x DCM Demo Utility.
   External D-RAM Test. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo scans continuously external D-RAM within
        the DSP environment.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  Demo and Signal Parameters:
  ---------------------------
        on-board configuration switch SW2:
	  - no BOOT mode
***********************************************************************/

#include <te54x_d.h>

unsigned *ptr ;

unsigned start_data = 0xa596,
         start_data_block,
	 *DMEM_START_PTR,
	 *DMEM_END_PTR,
	 dram_pages;
unsigned mem_inc_data = 0x97b5;
unsigned mem_wr_data;
unsigned long pass_counter=0;
int page;


main()
{
	// initialize DSP on-chip control registers
   TE54X_init_for_xdm_dram();

   DMEM_END_PTR	= ((unsigned *) 0xff7f);

	// configure DMEM_START_PTR and DRAM_PAGES upon the DSP type
   if(TE5402_BOARD)
	{
		DMEM_START_PTR=((unsigned *) TE5402_DRAM_PAGE_SADDR);
		dram_pages = TE5402_DRAM_PAGES;
	}
     else
	{
		DMEM_START_PTR=((unsigned *) TE54X_NOTE5402_DRAM_PAGE_SADDR);
		dram_pages = TE54X_NOTE5402_DRAM_PAGES;
	}

   TE54X_SET_XDM_SEL_DRAM;

   while(1)
    {
      start_data_block= start_data;

      for(page=0; page<dram_pages; page++)
        {
          TE54X_set_xdm_page(page);

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ;)
	    {
		*ptr++ = mem_wr_data++;
	    }

          start_data += mem_inc_data ;
        }

      start_data=start_data_block;
      for(page=0; page<dram_pages; page++)
        {
          TE54X_set_xdm_page(page);
          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ;	)
   	   {
             if(*ptr++ != mem_wr_data++) goto error ;
	   }

          start_data += mem_inc_data ;
        }

     pass_counter++;

    }


  error:
    while(1) ;
}



