/********************************************************************
   TORNADO-E54x DCM Demo Utility.
   USART PIO Test. rev.1A
   (C) MicroLAB Systems, 2000


   Description:
   ------------
	This demo continuously generates 'running '1'' over 8-bit 
	USART parallel I/O port, which is available via JP__ on-board
	connector.


   TORNADO platform:
   -----------------
	This demo does not utilize any host TORNADO resources
	and runs in stand-alone mode. MIRAGE JTAG emulator and
	TI CCS tools are required to recompile this demo and to
	upload code to the on-board DSP environment.

  Copyright:
  ----------
	This demo is distributed free of charge and as it is without
	any obligation from MicroLAB Systems.


  board configuration and demo parameters:
  ----------------------------------------
        on-board configuration switch SW2:
	  - no BOOT mode
***********************************************************************/

#include	"te54x_d.h"



void main()
{
	int i;

	// initialize DSP for running with SRAM as D-MEM
	TE54X_init_for_xdm_dram();

	// configure USART PIO port as outputs
	TE54X_set_usart_rg(TE54X_USART_A_PCR_RG,0);


	// continuously generate 'running '1''
	while(1)
	 {
	   TE54X_set_usart_rg(TE54X_USART_A_PVR_RG,1);

	   for(i=1;i<8;i++)
	       TE54X_set_usart_rg(TE54X_USART_A_PVR_RG,
				  TE54X_get_usart_rg(TE54X_USART_A_PVR_RG)<<1
				 );
	 }
}